

clear;
close all;
clc;

MAINPATH = 'Z:\Florian\tMentRotNew\analysis\';
PATHIN = [MAINPATH, '\artStrength\'];

addpath('Z:\Florian\fieldtrip\');
ft_defaults;

load([PATHIN, 'AVGartRatio.mat']);
load mni_grid_1_5_cm_889pnts.mat;
load standard_mri.mat;


artRatioFig = figure;

for blk = 1:2
    
    switch blk
        case 1
            figPos = 1;
        case 2
            figPos = 5;
    end
    
    source = template_grid;
    source.pow = NaN(length(source.inside),1);
    source.pow(source.inside) = mean(ArtfctRatioSource(:,blk,:),1);
    
    cfg = [];
    cfg.parameter = 'pow';
    scr_int = ft_sourceinterpolate(cfg,source,mri);
    scr_int.mask = scr_int.pow;
    
    cfg = [];
    cfg.funparameter = 'pow';
    cfg.method = 'surface';
    %cfg.method = 'slice';
    %cfg.maskparameter = 'mask';
    cfg.funcolormap = jet;
    cfg.camlight = 'no';
    cfg.downsample = 1;
    cfg.nslices = 9;
    cfg.surffile = 'surface_white_left.mat';
    cfg.surfinflated = 'surface_inflated_left_caret.mat';
    cfg.opacitymap = 'rampup';
    cfg.opacitylim = [2 10];
    cfg.funcolorlim = [1 10];
    
    ft_sourceplot(cfg,scr_int); axis tight;
    view([-56 16]);
    
    h = gcf;
    hax1 = gca;
    figure(artRatioFig);
    s1 = subplot(2,4,figPos);
    pos = get(s1,'Position');
    delete(s1);
    hax2 = copyobj(hax1,artRatioFig);
    set(hax2, 'Position', pos);
    set(artRatioFig, 'colormap', jet);
    drawnow;
    close(h);
    
    cfg = [];
    cfg.funparameter = 'pow';
    cfg.method = 'surface';
    %cfg.method = 'slice';
    %cfg.maskparameter = 'mask';
    cfg.funcolormap = jet;
    cfg.camlight = 'no';
    cfg.downsample = 1;
    cfg.nslices = 9;
    cfg.surffile = 'surface_white_right.mat';
    cfg.surfinflated = 'surface_inflated_right_caret.mat';
    cfg.opacitymap = 'rampup';
    cfg.opacitylim = [2 10];
    cfg.funcolorlim = [1 10];
    
    ft_sourceplot(cfg,scr_int); axis tight;
    view([56 16]);
    
    h = gcf;
    hax1 = gca;
    figure(artRatioFig);
    s1 = subplot(2,4,figPos+1);
    pos = get(s1,'Position');
    delete(s1);
    hax2 = copyobj(hax1,artRatioFig);
    set(hax2, 'Position', pos);
    set(artRatioFig, 'colormap', jet);
    drawnow;
    close(h);
    
    cfg = [];
    cfg.funparameter = 'pow';
    cfg.method = 'surface';
    %cfg.method = 'slice';
    %cfg.maskparameter = 'mask';
    cfg.funcolormap = jet;
    cfg.camlight = 'no';
    cfg.downsample = 1;
    cfg.nslices = 9;
    cfg.surffile = 'surface_white_right.mat';
    cfg.surfinflated = 'surface_inflated_right_caret.mat';
    cfg.opacitymap = 'rampup';
    cfg.opacitylim = [2 10];
    cfg.funcolorlim = [1 10];
    
    ft_sourceplot(cfg,scr_int); axis tight;
    view([-56 16]);
    
    h = gcf;
    hax1 = gca;
    figure(artRatioFig);
    s1 = subplot(2,4,figPos+3);
    pos = get(s1,'Position');
    delete(s1);
    hax2 = copyobj(hax1,artRatioFig);
    set(hax2, 'Position', pos);
    set(artRatioFig, 'colormap', jet);
    drawnow;
    close(h);
    
    cfg = [];
    cfg.funparameter = 'pow';
    cfg.method = 'surface';
    %cfg.method = 'slice';
    %cfg.maskparameter = 'mask';
    cfg.funcolormap = jet;
    cfg.camlight = 'no';
    cfg.downsample = 1;
    cfg.nslices = 9;
    cfg.surffile = 'surface_white_left.mat';
    cfg.surfinflated = 'surface_inflated_left_caret.mat';
    cfg.opacitymap = 'rampup';
    cfg.opacitylim = [2 10];
    cfg.funcolorlim = [1 10];
    
    ft_sourceplot(cfg,scr_int); axis tight;
    view([56 16]);
    
    h = gcf;
    hax1 = gca;
    figure(artRatioFig);
    s1 = subplot(2,4,figPos+2);
    pos = get(s1,'Position');
    delete(s1);
    hax2 = copyobj(hax1,artRatioFig);
    set(hax2, 'Position', pos);
    set(artRatioFig, 'colormap', jet);
    drawnow;
    close(h);
    
end
%
c1 = colorbar('location','southoutside','AxisLocation', 'out');
c1.Label.String = 'Artifact-to-brain-signal-ratio';
c1.Position = [0.15, 0.46, 0.75, 0.02];
c1.TickLabels = {'1:1', '2:1', '3:1', '4:1', '5:1', '6:1', '7:1', '8:1', '9:1', '10:1'};
c1.FontSize = 32;

load([PATHIN, 'SUBJ_03artStrength.mat']);
data = MEG{1};

data.dimord = 'chan_freq';
data.powspctrm = squeeze(mean(ArtfctRatioSens(:,1,:)));
data.freq = 10;
data = rmfield(data,'time');

data = ft_combineplanar([],data);

cfg = [];

cfg.zlim = [1 10e6];
cfg.colormap = jet;

figure;
subplot(2,2,1);
cfg.layout = 'neuromag306mag.lay';
ft_topoplotER(cfg,data);
subplot(2,2,2);
cfg.layout = 'neuromag306cmb.lay';
ft_topoplotER(cfg,data);

data = MEG{1};

data.dimord = 'chan_freq';
data.powspctrm = squeeze(mean(ArtfctRatioSens(:,2,:)));
data.freq = 10;
data = rmfield(data,'time');

data = ft_combineplanar([],data);

subplot(2,2,3);
cfg.layout = 'neuromag306mag.lay';
ft_topoplotER(cfg,data);
subplot(2,2,4);
cfg.layout = 'neuromag306cmb.lay';
ft_topoplotER(cfg,data);
