clear;
close all;
clc;

doPlot = 1;

MAINPATH = '/data3/Florian/tMentRotNew/analysis/';
PATHINMEG = [MAINPATH, 'resampled/'];
PATHINFILT = [MAINPATH, 'lcmv/'];
PATHOUT = [MAINPATH, 'TFR/'];
mkdir(PATHOUT);

addpath('/data3/Florian/fieldtrip/');
addpath(genpath([MAINPATH, 'scripts/functions/']));
ft_defaults;

SUBJ = {'01', '02', '03', '04', '05', '06', '07', '08', '09', '10', '11', '12', '13', '14', '15', '16', '17', '18', '19', '20', '21', '22', '23', '24', '25'};
%SUBJ = {'03', '10', '13', '18', '20', '21'};
EXCL = {'01', '10', '16', '24', '25'};
allData = cell(length(SUBJ), 2);
idxStim = zeros(1,length(SUBJ));
idxSham = idxStim;
idxExcl = idxStim;
figure;
for sbj = 1:length(SUBJ)
    
    %% load data and beamformer filters
    disp(['loading Subject', SUBJ{sbj}])
    filename = ['tm_', SUBJ{sbj}, '_rs.mat'];
    
    load([PATHINMEG, filename]);
    
    PATHINRAW = [MAINPATH, 'rawdir/tm', SUBJ{sbj}, 'a/'];
    filename = ['VP_', SUBJ{sbj}, '.mat'];
    
    load([PATHINRAW, filename]);
    
    data = ft_combineplanar([],data);  
    
    cfg = [];
    cfg.hpfilter = 'yes';
    cfg.hpfreq = BEHAV.frequency - 1;
    cfg.lpfilter = 'yes';
    cfg.lpfreq = BEHAV.frequency + 1;
    
    data = ft_preprocessing(cfg,data);
    

    
    data.trial{1} = abs(hilbert(data.trial{1}'))';
%     %[data.trial{1}, ~] = envelope(data.trial{1}', 250, 'analytic');
    %data.trial{1} = data.trial{1}'; 
    
    cfg = [];
    cfg.lpfilter = 'yes';
    cfg.lpfreq = 7;
    data = ft_preprocessing(cfg,data);
    
    if ismember(SUBJ{sbj}, EXCL)
        
        idxExcl(sbj) = 1;
        
    else
        
        switch BEHAV.condition
            case 's'
                idxStim(sbj) = 1;
            case 'c'
                idxSham(sbj) = 1;
        end
        
    end
    
    
     %% segment MEG data
    
    idx100 = find([EVENTS.value] == 100);
    
    cfg = [];
    cfg.trl(:,1) = [EVENTS(idx100).sample]-4*data.fsample;
    cfg.trl(:,2) = [EVENTS(idx100).sample]+7*data.fsample-1;
    cfg.trl(:,3) = 0;
    
    data = ft_redefinetrial(cfg,data);
    
    cfg = [];
    cfg.offset = -4*data.fsample;
    
    data = ft_redefinetrial(cfg,data);
    
    idxBlkEnd = 1:48:length(data.trial);
    idxBlkStart = idxBlkEnd;
    idxBlkStart(2) = idxBlkStart(2)+4;
    
    idxBlkStart = idxBlkStart([2 4]);
    idxBlkEnd = idxBlkEnd([3 5]);
    
    MEG = cell(1,length(idxBlkStart));
    
    %figure;
    for blk = 1:2
        
        cfg = [];
        cfg.channel = 'MEG';
        cfg.trials = idxBlkStart(blk):idxBlkEnd(blk)+47;
        
        MEG{blk} = ft_timelockanalysis(cfg,data);
        
        allData{sbj,blk} = MEG{blk};
        
    end
    
    subplot(5,5,sbj);
%     cfg = [];
%     cfg.channel = 'MEGMAG';
%     cfg.layout = 'neuromag306mag.lay';
%     cfg.xlim = [-3 4];
%     ft_singleplotER(cfg,MEG{:});
    
    cfg = [];
    cfg.channel = 'MEGGRAD';
    cfg.layout = 'neuromag306cmb.lay';
    cfg.baseline = [-3 7];
    cfg.baselinetype = 'absolute';
    ft_singleplotER(cfg,MEG{:});
    title(SUBJ{sbj});
    drawnow;
end

idxStim = find(idxStim);
idxSham = find(idxSham);
idxExcl = find(idxExcl);
AvgERE = cell(2,7);

cfg = [];
cfg.baseline = [-3 4];
cfg.baselinetype = 'absolute';

allData = cellfun(@(x) ft_timelockbaseline(cfg,x), allData, 'UniformOutput', 0);

cfg = [];
cfg.latency = [-2.5 -0.5];
cfg.avgovertime = 'yes';

preData = cellfun(@(x) ft_selectdata(cfg,x), allData, 'UniformOutput', 0);

cfg = [];
cfg.latency = [0 2];
cfg.avgovertime = 'yes';

postData = cellfun(@(x) ft_selectdata(cfg,x), allData, 'UniformOutput', 0);

postData = cellfun(@(x) setfield(x, 'time', -1.5), postData, 'UniformOutput',0);

figure;
for blk = 1:2
    
    cfg = [];
    AvgERE{2,blk} = ft_timelockgrandaverage(cfg,allData{idxStim,blk});
    AvgERE{1,blk} = ft_timelockgrandaverage(cfg,allData{idxSham,blk});
    
%     subplot(2,7,blk);
%     cfg = [];
%     cfg.channel = 'MEGMAG';
%     ft_singleplotER(cfg,AvgERE{:,blk});
%     title('');
%     subplot(2,7,blk+7);
%     cfg.channel = 'MEGGRAD';
%     ft_singleplotER(cfg,AvgERE{:,blk});
%     title('');
    
end

for i = 1:length(allData)
cfg = [];
cfg.layout = 'neuromag306cmb.lay';
figure;
subplot(2,1,1);
ft_multiplotER(cfg,allData{i,1});
set(gcf,'position', get(0,'screensize'));
if intersect(idxStim,i)>0
    condn = 's';
elseif intersect(idxSham,i)>0
    condn = 'c';
else
    condn = 'excl';
end
title(['SBJ', SUBJ{i}, condn]);
subplot(2,1,2);
cfg.layout = 'neuromag306mag.lay';
ft_multiplotER(cfg,allData{i,1});
saveas(gcf,['SBJ', SUBJ{i}, 'env.png'], 'png');
close(gcf);
end

cfg = [];
cfg.layout = 'neuromag306cmb.lay';
figure;
ft_multiplotER(cfg,allData{idxStim,1});

cfg = [];
cfg.linewidth = 2;
ft_singleplotER(cfg,allData{idxStim,1}); hold on;
plot(AvgERE{2,1}.time, mean(AvgERE{2,1}.avg(1:101,:),1), 'k','LineWidth', 6); hold on; xlim([-3 4]);

%% permutation testing

cfg = [];
cfg.method = 'distance';
neighbours = ft_prepare_neighbours(cfg,preData{1});

cfg = [];
cfg.channel = 'MEGMAG';
cfg.method = 'montecarlo';
cfg.correctm = 'cluster';
cfg.statistic = 'ft_statfun_depsamplesT';
cfg.design(1,:) = [ones(1,length({postData{idxStim,1}})) ones(1,length({postData{idxStim,1}}))*2];
cfg.design(2,:) = [1:length({postData{idxStim,1}}) 1:length({postData{idxStim,1}})];
cfg.ivar = 1;
cfg.uvar = 2;
cfg.parameter = 'avg';
cfg.neighbours = neighbours;
cfg.numrandomization = 1000;

statStim = ft_timelockstatistics(cfg,preData{idxStim,1}, postData{idxStim,1});

cfg = [];
cfg.channel = 'MEGMAG';
cfg.method = 'montecarlo';
cfg.correctm = 'cluster';
cfg.statistic = 'ft_statfun_depsamplesT';
cfg.design(1,:) = [ones(1,length({postData{idxSham,1}})) ones(1,length({postData{idxSham,1}}))*2];
cfg.design(2,:) = [1:length({postData{idxSham,1}}) 1:length({postData{idxSham,1}})];
cfg.ivar = 1;
cfg.uvar = 2;
cfg.parameter = 'avg';
cfg.neighbours = neighbours;
cfg.numrandomization = 1000;

statSham = ft_timelockstatistics(cfg,preData{idxSham,1}, postData{idxSham,1});

cfg = [];
cfg.channel = 'MEGGRAD';
cfg.method = 'montecarlo';
cfg.correctm = 'cluster';
cfg.statistic = 'ft_statfun_depsamplesT';
cfg.design(1,:) = [ones(1,length({postData{idxStim,1}})) ones(1,length({postData{idxStim,1}}))*2];
cfg.design(2,:) = [1:length({postData{idxStim,1}}) 1:length({postData{idxStim,1}})];
cfg.ivar = 1;
cfg.uvar = 2;
cfg.parameter = 'avg';
cfg.neighbours = neighbours;
cfg.numrandomization = 1000;

statStim2 = ft_timelockstatistics(cfg,preData{idxStim,1}, postData{idxStim,1});

cfg = [];
cfg.channel = 'MEGGRAD';
cfg.method = 'montecarlo';
cfg.correctm = 'cluster';
cfg.statistic = 'ft_statfun_depsamplesT';
cfg.design(1,:) = [ones(1,length({postData{idxSham,1}})) ones(1,length({postData{idxSham,1}}))*2];
cfg.design(2,:) = [1:length({postData{idxSham,1}}) 1:length({postData{idxSham,1}})];
cfg.ivar = 1;
cfg.uvar = 2;
cfg.parameter = 'avg';
cfg.neighbours = neighbours;
cfg.numrandomization = 1000;

statSham2 = ft_timelockstatistics(cfg,preData{idxSham,1}, postData{idxSham,1});


%% Plot Results
cfg = [];
cfg.layout = 'neuromag306cmb.lay';
cfg.baseline = [-2.5 -0.5];
cfg.colormap = jet;
cfg.baselinetype = 'absolute';
cfg.xlim = [0 2];
cfg.zlim = [-200e-15 200e-15];
cfg.comment = 'no';
cfg.highlight = 'on';
cfg.highlightchannel = find(statStim2.mask);
cfg.highlightsymbol = '.';
cfg.highlightsize = 15;
figure;
subplot(4,2,1);
title('');
ft_topoplotER(cfg,AvgERE{2,1});
subplot(4,2,2);
cfg.highlight = 'on';
cfg.highlightchannel = find(statSham2.mask);
cfg.highlightsymbol = '.';
cfg.highlightsize = 15;
ft_topoplotER(cfg,AvgERE{1,1});
title('');

c1 = colorbar('location', 'southoutside','AxisLocation', 'out', 'FontSize', 24);
c1.Label.String = '\Deltaenvelope amplitude [fT/m]';
c1.Label.FontSize = 24;
c1.Ticks = linspace(-200e-15, 200e-15, 3);
c1.TickLabels = linspace(-200, 200, 3);
set(c1, 'position', [0.4 0.82 0.2 0.01]);

cfg.layout = 'neuromag306mag.lay';
cfg.zlim = [-50e-15 50e-15];
subplot(4,2,5);
title('');
cfg.highlight = 'on';
cfg.highlightchannel = find(statStim.mask)+101;
cfg.highlightsymbol = '.';
cfg.highlightsize = 15;
ft_topoplotER(cfg,AvgERE{2,1});
subplot(4,2,6);
cfg.highlight = 'on';
cfg.highlightchannel = find(statSham.mask)+101;
cfg.highlightsymbol = '.';
cfg.highlightsize = 15;
ft_topoplotER(cfg,AvgERE{1,1});
title('');

c1 = colorbar('location', 'southoutside','AxisLocation', 'out', 'FontSize', 24);
c1.Label.String = '\Deltaenvelope amplitude [fT]';
c1.Label.FontSize = 24;
c1.Ticks = linspace(-50e-15, 50e-15, 3);
c1.TickLabels = linspace(-50, 50, 3);
set(c1, 'position', [0.4 0.38 0.2 0.01]);

subplot(4,2,[3:4]);
[p1,q1]=boundedline(AvgERE{2,1}.time, mean(AvgERE{2,1}.avg(1:101,:),1),sem(AvgERE{2,1}.avg(1:101,:),[],1), 'r', 'alpha'); hold on; xlim([-3 4]); ylim([-150e-15 150e-15]);
[p2,q2]=boundedline(AvgERE{1,1}.time, mean(AvgERE{1,1}.avg(1:101,:),1),sem(AvgERE{1,1}.avg(1:101,:),[],1), 'b', 'alpha'); hold on;
plot([0 0], [-5e-13 5e-13], 'k', 'LineWidth', 2)
legend('Stimulation', 'Sham');
legend Boxoff;
plot(AvgERE{2,1}.time, mean(AvgERE{2,1}.avg(1:101,:),1), 'r', 'LineWidth', 2);
plot(AvgERE{1,1}.time, mean(AvgERE{1,1}.avg(1:101,:),1), 'b', 'LineWidth', 2);
outlinebounds(p1,q1);
outlinebounds(p2,q2);
xlabel('Time [sec]', 'FontSize', 24);
ylabel('Amplitude [fT/m]', 'FontSize', 18);
set(gca, 'FontSize', 24, 'YTick', linspace(-150e-15, 150e-15, 3), 'YTickLabels', linspace(-150, 150, 3));
subplot(4,2,[7:8]);
[p1,q1]=boundedline(AvgERE{2,1}.time, mean(AvgERE{2,1}.avg(102:end,:),1),sem(AvgERE{2,1}.avg(102:end,:),[],1), 'r', 'alpha'); hold on; xlim([-3 4]);ylim([-250e-15 250e-15]);
[p2,q2]=boundedline(AvgERE{1,1}.time, mean(AvgERE{1,1}.avg(102:end,:),1),sem(AvgERE{1,1}.avg(102:end,:),[],1), 'b', 'alpha'); hold on;
plot(AvgERE{2,1}.time, mean(AvgERE{2,1}.avg(102:end,:),1), 'r', 'LineWidth', 2);
plot(AvgERE{1,1}.time, mean(AvgERE{1,1}.avg(102:end,:),1), 'b', 'LineWidth', 2);
outlinebounds(p1,q1);
outlinebounds(p2,q2);
xlabel('Time [sec]');
ylabel('Amplitude [fT]');
plot([0 0], [-1e-12 1e-12], 'k', 'LineWidth', 2)
set(gca, 'FontSize', 24, 'YTick', linspace(-200e-15, 200e-15, 3), 'YTickLabels', linspace(-200, 200, 3));
% 
% cfg = [];
% cfg.layout = 'neuromag306cmb.lay';
% 
% ft_multiplotER(cfg, AvgERE{2,1});

artEnv = zeros(length(SUBJ), 2);

for sbj = 1:length(preData)

artEnv(sbj,1) = mean(preData{sbj,1}.avg(1:101)-postData{sbj,1}.avg(1:101));
artEnv(sbj,2) = mean(preData{sbj,1}.avg(102:end)-postData{sbj,1}.avg(102:end));

end

csvwrite([MAINPATH, 'stats/ArtfctEnv.csv'], artEnv);
    