function out = sem(X, flag, dim)
%
% sem(X, flag, dim) calculates Standard Errors of the Mean for Vector X. 
% 
% The arguments are passed to the Matlab std function and the calculated
% standard diviation is divided by the squareroot of the number of
% observations. 
%
% The optional input flag specifies the type of sdt formula used (see help
% std). Use default by entering an empty array []. dim referes to the
% dimension the SEM/std is calculated on. 

out = std(X, flag, dim)/sqrt(size(X, dim));

end